local DUFlocked = true
local playerDebuffsEnabled = true
local enemyBuffsEnabled = true
local friendlyBuffsEnabled = false
local DUFTooltipScale = 0.77
local tooltipBackdrop = true
local tooltipBorder = true
local iconsize = 40
local fontsize = iconsize/2
local cdpadding = 10
local cdcenterpoint = ( cdpadding + (iconsize/2) )
local bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 1, 1, 1, 1

local function DUF_ScanDebuffs()
    --Player debuffs
    local DUFunit = "player"
    local DUFaffect = "HARMFUL"

    --Player buffs for debugging
    -- local DUFunit = "target"
    -- local DUFaffect = "HELPFUL"

    if not UnitExists(DUFunit) then
        for i=1,10 do
            if _G["DUFDebuffTooltip"..i] then
                _G["DUFDebuffTooltip"..i]:ClearLines()
                _G["DUFDebuffTooltip"..i]:Hide()
            end
        end
    end

    for i=1,10 do            
        local aura = UnitAura(DUFunit,i, DUFaffect)        
        if aura then
            local _, _, count, debuffType, duration, expirationTime, source, isStealable, _, _, 
                canApplyAura, isBossDebuff, castByPlayer, _, timeMod = UnitAura(DUFunit,i, DUFaffect) 
            local tooltip
            local debuffscale = 1.5
            local timer
            --###### Make the tooltip
            if not _G["DUFDebuffTooltip"..i] then
                tooltip = CreateFrame("GameTooltip", "DUFDebuffTooltip"..i, UIParent, "GameTooltipTemplate")
                tooltip:SetFrameStrata("BACKGROUND")
                tooltip:SetWidth(600)

                tooltip.debuffCD = CreateFrame("Button", "DUFDebuffIconFrame"..i, tooltip)
                tooltip.debuffCD:ClearAllPoints()		
                tooltip.debuffCD:SetPoint("TOPRIGHT", tooltip, "TOPRIGHT", -cdpadding/debuffscale, -cdpadding/debuffscale)
                tooltip.debuffCD:SetScale( debuffscale ) -- Scale up the timer text
                tooltip.debuffCD:SetSize(iconsize/debuffscale, iconsize/debuffscale) --Scale down the icon

                --Create tooltip.debuffCD Icon Textures
                tooltip.debuffCD.icon = tooltip.debuffCD:CreateTexture("DUFDebuffIcon"..i,"OVERLAY")
                tooltip.debuffCD.icon:SetAllPoints("DUFDebuffIconFrame"..i)

                --Create Buff Animation Frames
                tooltip.debuffCD.debuff = CreateFrame("Cooldown", "BuffAnimation"..i, tooltip.debuffCD, "CooldownFrameTemplate")
                tooltip.debuffCD.debuff:SetHideCountdownNumbers(false); -- Hides the countdown numbers regardless of the cvar setting
                tooltip.debuffCD.debuff:SetSwipeTexture("Interface\\Cooldown\\cooldown2")

                --Center the timer text
                timer = tooltip.debuffCD.debuff:GetRegions()
                timer:SetFontObject(GameFontHighlightSmallOutline)
                timer.SetFontObject = nop
                timer.SetFont = nop
                
                if (duration > 60) then
                    timer:SetScale( debuffscale*0.77 ) -- Scale down the timer text
                else
                    timer:SetScale( debuffscale ) -- Scale up the timer text
                    -- timer.SetScale = nop --Don't use or can't use onupdate
                end

                timer:ClearAllPoints()
                timer.ClearAllPoints = nop
                
                timer:SetPoint("CENTER", tooltip.debuffCD, "CENTER", debuffscale/8, 0)
                timer.SetPoint = nop

                --Create Buff Stack Count Text Strings
                tooltip.debuffCD.debuff.stack = tooltip.debuffCD.debuff:CreateFontString("FontString","OVERLAY","GameTooltipText", 7)
                tooltip.debuffCD.debuff.stack:SetFontObject("GameFontHighlightSmallOutline")                
                tooltip.debuffCD.debuff.stack:SetTextColor(1, 1, 1);
                tooltip.debuffCD.debuff.stack:SetPoint("BOTTOMRIGHT", tooltip.debuffCD.debuff, "BOTTOMRIGHT",  0, 0)

                --Create Buff Charge Count Text Strings
                tooltip.debuffCD.debuff.charge = tooltip.debuffCD.debuff:CreateFontString("FontString","OVERLAY","GameTooltipText")
                tooltip.debuffCD.debuff.charge:SetFontObject("GameFontHighlightSmallOutline")    
                tooltip.debuffCD.debuff.charge:SetTextColor(1, 1, 1);
                tooltip.debuffCD.debuff.charge:SetPoint("BOTTOMRIGHT", tooltip.debuffCD.debuff, "BOTTOMRIGHT",  0, 0)

                --Create Active Buff Fade Alpha In & Out Animations
                tooltip.debuffCD.fadeAnimation = tooltip.debuffCD:CreateAnimationGroup()

                local bufffadein = tooltip.debuffCD.fadeAnimation:CreateAnimation("Alpha")
                bufffadein:SetSmoothing("NONE")	
                bufffadein:SetOrder(1)
                bufffadein:SetFromAlpha(1)
                bufffadein:SetToAlpha(0.33)
                bufffadein:SetDuration(1) --Blizzard default buff fade time is 0.80.
                
                local bufffadeout = tooltip.debuffCD.fadeAnimation:CreateAnimation("Alpha")
                bufffadeout:SetSmoothing("NONE")	
                bufffadeout:SetOrder(2)
                bufffadeout:SetFromAlpha(0.33)
                bufffadeout:SetToAlpha(1)
                bufffadeout:SetDuration(1)	

                -- local buffscalein = tooltip.debuffCD.fadeAnimation:CreateAnimation("Scale")
                -- buffscalein:SetSmoothing("IN_OUT")	
                -- buffscalein:SetOrder(1)
                -- buffscalein:SetFromScale(1, 1)
                -- buffscalein:SetToScale(1.05, 1.05)
                -- buffscalein:SetDuration(0.5) --Blizzard default buff fade time is 0.80.
                
                -- local buffscaleout = tooltip.debuffCD.fadeAnimation:CreateAnimation("Scale")
                -- buffscaleout:SetSmoothing("IN_OUT")	
                -- buffscaleout:SetOrder(2)
                -- buffscaleout:SetFromScale(1, 1)
                -- buffscaleout:SetToScale(0.952, 0.952)
                -- buffscaleout:SetDuration(0.5)	
            else
                tooltip = _G["DUFDebuffTooltip"..i]
                _G["DUFDebuffIcon"..i]:SetTexture(nil) --Can add custom textures later if wanted.
            end
            
            -- tooltip.debuffCD.debuff:SetCooldown(expirationTime-duration, duration-1) -- Subtract 1 so it ends with 0 instead of 1

            --Place Stack Count Text
            if count == nil then count = 0 end
            if count < 2 then
                tooltip.debuffCD.debuff.stack:SetText("");
            else
                tooltip.debuffCD.debuff.stack:SetText(count);
            end		
            --Show Remaining Time Text
            local timeremain = ((expirationTime - GetTime()) - duration)
            local DAStartTime = ( expirationTime - duration ) -- Minus one (-1) so it counts down to zero isntead of 1 and coincides with the default buff display.
            tooltip.debuffCD.debuff:SetCooldown( DAStartTime, duration)

            --Set the tooltip
            tooltip:SetScale(DUFTooltipScale)
            tooltip:ClearLines()
            tooltip:SetOwner(UIParent,"ANCHOR_PRESERVE")
            tooltip:SetUnitAura(DUFunit,i, DUFaffect)

            -- tooltip:SetBackdrop({
            --     bgFile = "Interface/Addons/DejaDeBuffTracker/DBTArt/DejaDBT-Tooltip-Background",
            --     edgeFile = "Interface/Addons/DejaDeBuffTracker/DBTArt/DejaDBT-Tooltip-Border",
            --     tile = false,
            --     tileSize = 1,
            --     tileEdge = false,
            --     edgeSize = 30,
            --     insets = { left = 0, right = 0, top = 0, bottom = 0 }
            -- })

            --Set the tooltip width
            local width = tooltip:GetWidth() + ( iconsize + cdpadding )
            tooltip:SetWidth(width)

            --Set the icon
            tooltip.debuffCD.icon:SetTexture(nil)
            local _, newicon = UnitAura(DUFunit,i, DUFaffect)

            tooltip.debuffCD.icon:SetTexture(newicon)
            -- _G["DUFDebuffIcon"..i]:SetTexture(icon) --Can add custom textures later if wanted.

            -- Get the global name of the tooltip object:
            local name = tooltip:GetName()
            local lastlinenumber =tooltip:NumLines()

            -- Loop over each line in the tooltip:
            for j = 1, tooltip:NumLines() do
                -- Get a reference to the left-aligned text on this line:
                local leftline = _G[name .. "TextLeft" .. j]
                local lefttext = leftline:GetText()
                local leftlength1
                local leftlength2
                
                if lefttext == nil then
                    lefttext = ""
                end
                
                -- Do the same for the right-aligned text:
                local rightline = _G[name .. "TextRight" .. j]
                local righttext = rightline:GetText()

                if righttext == nil then
                    righttext = ""
                end

                --Colors
                if debuffType then
                    --Set background color
                    if not debuffType == nil then -- Catch-all for any other debuff types (bleeds) that aren't nil.
                        bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 1, 0.5, 0.5, 1
                        tooltip:SetBackdropColor(1, 0, 0, 0.33) -- Red
                        tooltip:SetBackdropBorderColor(1, 0, 0, 0.33) -- Red
                    end
                    if debuffType == "Curse" then
                        bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 1, 0.5, 1, 1
                        tooltip:SetBackdropColor(1, 0, 1, 0.33) -- Purple
                        tooltip:SetBackdropBorderColor(1, 0, 1, 0.33) -- Purple
                    end
                    if debuffType == "Disease" then
                        bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 1, 1, 0.5, 1
                        tooltip:SetBackdropColor(1, 1, 0, 0.33) -- Yellow
                        tooltip:SetBackdropBorderColor(1, 1, 0, 0.33) -- Yellow
                    end
                    if (debuffType == "Magic") then
                        bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 0.5, 0.5, 1, 1
                        tooltip:SetBackdropColor(0, 0, 1, 0.33) -- Blue
                        tooltip:SetBackdropBorderColor(0, 0, 1, 0.33) -- Blue
                    end
                    if debuffType == "Poison" then
                        bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 0.5, 1, 0.5, 1
                        tooltip:SetBackdropColor(0, 1, 0, 0.33) -- Green
                        tooltip:SetBackdropBorderColor(0, 1, 0, 0.33) -- Green
                    end

                    -- Set line 1 debuff name and debuff type text font and colors
                    if (j == 1) then
                        leftline:SetTextColor(bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a)                        

                        rightline:SetTextColor(bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a)
                    end
                    tooltip.debuffCD.debuff:SetSwipeColor(bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, 1);

                    local _, _, _, debuffType = UnitAura(DUFunit,i, DUFaffect.."|RAID") 
                    if debuffType then --If you can dispell it
                        tooltip:SetBackdropBorderColor(1, 1, 1, 0.77) -- White
                    end
                    if isBossDebuff then --If the boss applied it.
                        tooltip:SetBackdropBorderColor(1, 0, 0, 0.77) -- Red
                    end
                else
                    -- bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 1, 1, 1, 1 -- White text all others 
                    tooltip:SetBackdropColor(0, 0, 0, 0.7) -- Black background all others
                    tooltip:SetBackdropBorderColor(0, 0, 0, 0.7) -- Black background all others
                    if (j == 1) then
                        -- leftline:SetText(lefttext)
                        bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 1, 0.85, 0, 1 -- Yellow line 1 debuff name and debuff type text all others 
                    end
                    tooltip.debuffCD.debuff:SetSwipeColor(0, 0, 0, 0.77);
                    -- tooltip.debuffCD.debuff:GetRegions():SetTextColor(1,1,1,1);
                end
                
                --Get the last left line which is the time remaining and set it every second below 1 minute.
                if (j == lastlinenumber) then
                    local fontName, fontHeight, fontFlags = leftline:GetFont()

                    --Set the tooltip height
                    local height = tooltip:GetHeight()
                    local minheight = ( iconsize + (cdpadding * 2) )
                    local newheight = ( height-(fontHeight*1.5) )
                    
                    tooltip:SetHeight(height)

                    if duration > 0 then
                        tooltip:SetHeight(newheight)
                    end
                    if ( newheight < minheight ) then
                        tooltip:SetHeight(minheight)
                    end
                    -- print(height, "{[("..minheight..")]}", newheight, "{[("..aura..")]}")

                    --Get total length of all tooltip text (character count)
                    --Note there may be localization issues but for now "assume" that character count is universal for tooltip display
                    local jlength = 0
                    local totaldesclength = 0
                    for j = 2, tooltip:NumLines() do
                        jlength = string.len(_G[name .. "TextLeft" .. j]:GetText())
                        if ( jlength == 19 ) or ( jlength == 20 ) then 
                            jlength = 0 
                        end
                        totaldesclength = totaldesclength + jlength
                        -- print(j, "Total: "..totaldesclength, "Line: "..jlength, aura)
                        if (jlength > 83) then
                            tooltip:SetHeight(height) --Longer text needs more room, for example: Dire Bear Form aura
                        end
                    end

                    if (duration == 0) then
                        leftline:SetText(lefttext)
                    else
                        leftline:SetText("")
                    end
                    local timeElapsed = 0
                    local timer = tooltip.debuffCD.debuff:GetRegions()
                    tooltip:HookScript("OnUpdate", function(self, elapsed)
                        timeElapsed = timeElapsed + elapsed
                        local onupdate_expirationTime = select(6,UnitAura(DUFunit,i, DUFaffect))
                        if (timeElapsed > 0.1) then
                            timeElapsed = 0
                            if onupdate_expirationTime then
                                local timeremain = (onupdate_expirationTime - GetTime())
                                onupdate_expirationTime = 0
                                if (timeremain > 0) then
                                    if (timeremain < 60) then
                                        if not tooltip.debuffCD.fadeAnimation:IsPlaying() then
                                            tooltip.debuffCD.fadeAnimation:Play()
                                        end
                                    else
                                        tooltip.debuffCD.fadeAnimation:Stop()
                                    end
                                    local timertextremain = (expirationTime - GetTime())
                                    if (timertextremain > 60) then
                                        timer:SetScale( debuffscale*0.77 ) -- Scale down the timer text
                                    end
                                end
                                timeremain = 0
                            end
                        end
                    end)
                else
                    leftline:SetText(lefttext)
                    rightline:SetText(righttext)
                end
            end

            --Anchors
            local prev = UnitAura(DUFunit,i-1, DUFaffect)
            if prev then
                tooltip:SetPoint("BOTTOMRIGHT", _G["DUFDebuffTooltip"..i-1], "TOPRIGHT", 0,4)
            else
                tooltip:SetPoint("BOTTOMRIGHT", DUFDebuffTooltipParent, "BOTTOMRIGHT", 0,0)
            end
        else
            if _G["DUFDebuffTooltip"..i] then
                _G["DUFDebuffTooltip"..i]:Hide()
            end
        end
    end
end

--####### #######

local function DUF_ScanBuffs()
    --Player buffs
    -- local DUFunit = "player"
    -- local DUFaffect = "HARMFUL"

    --Player buffs for debugging
    local DUFunit = "target"
    local DUFaffect = "HELPFUL"

    if not UnitExists(DUFunit) then
        for i=1,10 do
            if _G["DUFBuffTooltip"..i] then
                _G["DUFBuffTooltip"..i]:ClearLines()
                _G["DUFBuffTooltip"..i]:Hide()
            end
        end
    end

    for i=1,10 do            
        local aura = UnitAura(DUFunit,i, DUFaffect)        
        if aura then
            local _, _, count, debuffType, duration, expirationTime, source, isStealable, _, _, 
                canApplyAura, isBossDebuff, castByPlayer, _, timeMod = UnitAura(DUFunit,i, DUFaffect) 
            local tooltip
            local buffscale = 1.5
            local timer
            --###### Make the tooltip
            if not _G["DUFBuffTooltip"..i] then
                tooltip = CreateFrame("GameTooltip", "DUFBuffTooltip"..i, UIParent, "GameTooltipTemplate")
                tooltip:SetFrameStrata("BACKGROUND")
                tooltip:SetWidth(600)

                tooltip.buffCD = CreateFrame("Button", "DUFBuffIconFrame"..i, tooltip)
                tooltip.buffCD:ClearAllPoints()		
                tooltip.buffCD:SetPoint("TOPLEFT", tooltip, "TOPLEFT", cdpadding/buffscale, -cdpadding/buffscale)
                tooltip.buffCD:SetScale( buffscale ) -- Scale up the timer text
                tooltip.buffCD:SetSize(iconsize/buffscale, iconsize/buffscale) --Scale down the icon

                --Create tooltip.buffCD Icon Textures
                tooltip.buffCD.icon = tooltip.buffCD:CreateTexture("DUFBuffIcon"..i,"OVERLAY")
                tooltip.buffCD.icon:SetAllPoints("DUFBuffIconFrame"..i)

                --Create Buff Animation Frames
                tooltip.buffCD.buff = CreateFrame("Cooldown", "BuffAnimation"..i, tooltip.buffCD, "CooldownFrameTemplate")
                tooltip.buffCD.buff:SetHideCountdownNumbers(false); -- Hides the countdown numbers regardless of the cvar setting
                tooltip.buffCD.buff:SetSwipeTexture("Interface\\Cooldown\\cooldown2")

                --Center the timer text
                timer = tooltip.buffCD.buff:GetRegions()
                timer:SetFontObject(GameFontHighlightSmallOutline)
                timer.SetFontObject = nop
                timer.SetFont = nop
                
                if (duration > 60) then
                    timer:SetScale( buffscale*0.77 ) -- Scale down the timer text
                else
                    timer:SetScale( buffscale ) -- Scale up the timer text
                    -- timer.SetScale = nop --Don't use or can't use onupdate
                end

                timer:ClearAllPoints()
                timer.ClearAllPoints = nop
                
                timer:SetPoint("CENTER", tooltip.buffCD, "CENTER", buffscale/8, 0)
                timer.SetPoint = nop

                --Create Buff Stack Count Text Strings
                tooltip.buffCD.buff.stack = tooltip.buffCD.buff:CreateFontString("FontString","OVERLAY","GameTooltipText", 7)
                tooltip.buffCD.buff.stack:SetFontObject("GameFontHighlightSmallOutline")                
                tooltip.buffCD.buff.stack:SetTextColor(1, 1, 1);
                tooltip.buffCD.buff.stack:SetPoint("BOTTOMRIGHT", tooltip.buffCD.buff, "BOTTOMRIGHT",  0, 0)

                --Create Buff Charge Count Text Strings
                tooltip.buffCD.buff.charge = tooltip.buffCD.buff:CreateFontString("FontString","OVERLAY","GameTooltipText")
                tooltip.buffCD.buff.charge:SetFontObject("GameFontHighlightSmallOutline")    
                tooltip.buffCD.buff.charge:SetTextColor(1, 1, 1);
                tooltip.buffCD.buff.charge:SetPoint("BOTTOMRIGHT", tooltip.buffCD.buff, "BOTTOMRIGHT",  0, 0)

                --Create Active Buff Fade Alpha In & Out Animations
                tooltip.buffCD.fadeAnimation = tooltip.buffCD:CreateAnimationGroup()

                local bufffadein = tooltip.buffCD.fadeAnimation:CreateAnimation("Alpha")
                bufffadein:SetSmoothing("NONE")	
                bufffadein:SetOrder(1)
                bufffadein:SetFromAlpha(1)
                bufffadein:SetToAlpha(0.33)
                bufffadein:SetDuration(1) --Blizzard default buff fade time is 0.80.
                
                local bufffadeout = tooltip.buffCD.fadeAnimation:CreateAnimation("Alpha")
                bufffadeout:SetSmoothing("NONE")	
                bufffadeout:SetOrder(2)
                bufffadeout:SetFromAlpha(0.33)
                bufffadeout:SetToAlpha(1)
                bufffadeout:SetDuration(1)	

                -- local buffscalein = tooltip.buffCD.fadeAnimation:CreateAnimation("Scale")
                -- buffscalein:SetSmoothing("IN_OUT")	
                -- buffscalein:SetOrder(1)
                -- buffscalein:SetFromScale(1, 1)
                -- buffscalein:SetToScale(1.05, 1.05)
                -- buffscalein:SetDuration(0.5) --Blizzard default buff fade time is 0.80.
                
                -- local buffscaleout = tooltip.buffCD.fadeAnimation:CreateAnimation("Scale")
                -- buffscaleout:SetSmoothing("IN_OUT")	
                -- buffscaleout:SetOrder(2)
                -- buffscaleout:SetFromScale(1, 1)
                -- buffscaleout:SetToScale(0.952, 0.952)
                -- buffscaleout:SetDuration(0.5)	
            else
                tooltip = _G["DUFBuffTooltip"..i]
                _G["DUFBuffIcon"..i]:SetTexture(nil) --Can add custom textures later if wanted.
            end
            
            -- tooltip.buffCD.buff:SetCooldown(expirationTime-duration, duration-1) -- Subtract 1 so it ends with 0 instead of 1

            --Place Stack Count Text
            if count == nil then count = 0 end
            if count < 2 then
                tooltip.buffCD.buff.stack:SetText("");
            else
                tooltip.buffCD.buff.stack:SetText(count);
            end		
            --Show Remaining Time Text
            local timeremain = ((expirationTime - GetTime()) - duration)
            local DAStartTime = ( expirationTime - duration ) -- Minus one (-1) so it counts down to zero isntead of 1 and coincides with the default buff display.
            tooltip.buffCD.buff:SetCooldown( DAStartTime, duration)

            --Set the tooltip
            tooltip:SetScale(DUFTooltipScale)
            tooltip:ClearLines()
            tooltip:SetOwner(UIParent,"ANCHOR_PRESERVE")
            tooltip:SetUnitAura(DUFunit,i, DUFaffect)

            -- tooltip:SetBackdrop({
            --     bgFile = "Interface/Addons/DejaDeBuffTracker/DBTArt/DejaDBT-Tooltip-Background",
            --     edgeFile = "Interface/Addons/DejaDeBuffTracker/DBTArt/DejaDBT-Tooltip-Border",
            --     tile = false,
            --     tileSize = 1,
            --     tileEdge = false,
            --     edgeSize = 30,
            --     insets = { left = 0, right = 0, top = 0, bottom = 0 }
            -- })

            --Set the tooltip width
            local width = tooltip:GetWidth() + ( iconsize + cdpadding )
            tooltip:SetWidth(width)

            --Set the icon
            tooltip.buffCD.icon:SetTexture(nil)
            local _, newicon = UnitAura(DUFunit,i, DUFaffect)

            tooltip.buffCD.icon:SetTexture(newicon)
            -- _G["DUFBuffIcon"..i]:SetTexture(icon) --Can add custom textures later if wanted.

            -- Get the global name of the tooltip object:
            local name = tooltip:GetName()
            local lastlinenumber =tooltip:NumLines()

            -- Loop over each line in the tooltip:
            for j = 1, tooltip:NumLines() do
                -- Get a reference to the left-aligned text on this line:
                local leftline = _G[name .. "TextLeft" .. j]
                    leftline:SetPoint("LEFT", _G["DUFBuffTooltip"..i], "LEFT", ( iconsize + (cdpadding*2) ), 0)
                local lefttext = leftline:GetText()
                local leftlength1
                local leftlength2
                
                if lefttext == nil then
                    lefttext = ""
                end
                
                -- Do the same for the right-aligned text:
                local rightline = _G[name .. "TextRight" .. j]
                local righttext = rightline:GetText()

                if righttext == nil then
                    righttext = ""
                end

                --Colors
                if debuffType then
                    --Set background color
                    if not debuffType == nil then -- Catch-all for any other buff types (bleeds) that aren't nil.
                        bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 1, 0.5, 0.5, 1
                        tooltip:SetBackdropColor(1, 0, 0, 0.33) -- Red
                        tooltip:SetBackdropBorderColor(1, 0, 0, 0.33) -- Red
                    end
                    if debuffType == "Curse" then
                        bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 1, 0.5, 1, 1
                        tooltip:SetBackdropColor(1, 0, 1, 0.33) -- Purple
                        tooltip:SetBackdropBorderColor(1, 0, 1, 0.33) -- Purple
                    end
                    if debuffType == "Disease" then
                        bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 1, 1, 0.5, 1
                        tooltip:SetBackdropColor(1, 1, 0, 0.33) -- Yellow
                        tooltip:SetBackdropBorderColor(1, 1, 0, 0.33) -- Yellow
                    end
                    if (debuffType == "Magic") then
                        bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 0.5, 0.5, 1, 1
                        tooltip:SetBackdropColor(0, 0, 1, 0.33) -- Blue
                        tooltip:SetBackdropBorderColor(0, 0, 1, 0.33) -- Blue
                    end
                    if debuffType == "Poison" then
                        bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 0.5, 1, 0.5, 1
                        tooltip:SetBackdropColor(0, 1, 0, 0.33) -- Green
                        tooltip:SetBackdropBorderColor(0, 1, 0, 0.33) -- Green
                    end

                    -- Set line 1 buff name and buff type text font and colors
                    if (j == 1) then
                        leftline:SetTextColor(bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a)                        

                        rightline:SetTextColor(bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a)
                    end
                    tooltip.buffCD.buff:SetSwipeColor(bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, 1);

                    local _, _, _, debuffType, _, _, _, isStealable = UnitAura(DUFunit,i, DUFaffect.."|RAID") 
                    if debuffType or isStealable then --If you can purge or steal it
                        tooltip:SetBackdropBorderColor(1, 1, 1, 0.77) -- White
                    end
                else
                    -- bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 1, 1, 1, 1 -- White text all others 
                    tooltip:SetBackdropColor(0, 0, 0, 0.7) -- Black background all others
                    tooltip:SetBackdropBorderColor(0, 0, 0, 0.7) -- Black background all others
                    if (j == 1) then
                        -- leftline:SetText(lefttext)
                        bufftextcolor_r, bufftextcolor_g, bufftextcolor_b, bufftextcolor_a = 1, 0.85, 0, 1 -- Yellow line 1 buff name and buff type text all others 
                    end
                    tooltip.buffCD.buff:SetSwipeColor(0, 0, 0, 0.77);
                    -- tooltip.buffCD.buff:GetRegions():SetTextColor(1,1,1,1);
                end
                
                --Get the last left line which is the time remaining and set it every second below 1 minute.
                if (j == lastlinenumber) then
                    local fontName, fontHeight, fontFlags = leftline:GetFont()

                    --Set the tooltip height
                    local height = tooltip:GetHeight()
                    local minheight = ( iconsize + (cdpadding * 2) )
                    local newheight = ( height-(fontHeight*1.5) )
                    
                    tooltip:SetHeight(height)

                    if duration > 0 then
                        tooltip:SetHeight(newheight)
                    end
                    if ( newheight < minheight ) then
                        tooltip:SetHeight(minheight)
                    end
                    -- print(height, "{[("..minheight..")]}", newheight, "{[("..aura..")]}")

                    --Get total length of all tooltip text (character count)
                    --Note there may be localization issues but for now "assume" that character count is universal for tooltip display
                    local jlength = 0
                    local totaldesclength = 0
                    for j = 2, tooltip:NumLines() do
                        jlength = string.len(_G[name .. "TextLeft" .. j]:GetText())
                        if ( jlength == 19 ) or ( jlength == 20 ) then 
                            jlength = 0 
                        end
                        totaldesclength = totaldesclength + jlength
                        -- print(j, "Total: "..totaldesclength, "Line: "..jlength, aura)
                        if (jlength > 83) then
                            tooltip:SetHeight(height) --Longer text needs more room, for example: Dire Bear Form aura
                        end
                    end

                    if (duration == 0) then
                        leftline:SetText(lefttext)
                    else
                        leftline:SetText("")
                    end
                    local timeElapsed = 0
                    local timer = tooltip.buffCD.buff:GetRegions()
                    tooltip:HookScript("OnUpdate", function(self, elapsed)
                        timeElapsed = timeElapsed + elapsed
                        local onupdate_expirationTime = select(6,UnitAura(DUFunit,i, DUFaffect))
                        if (timeElapsed > 0.1) then
                            timeElapsed = 0
                            if onupdate_expirationTime then
                                local timeremain = (onupdate_expirationTime - GetTime())
                                onupdate_expirationTime = 0
                                if (timeremain > 0) then
                                    if (timeremain < 60) then
                                        if not tooltip.buffCD.fadeAnimation:IsPlaying() then
                                            tooltip.buffCD.fadeAnimation:Play()
                                        end
                                    else
                                        tooltip.buffCD.fadeAnimation:Stop()
                                    end
                                    local timertextremain = (expirationTime - GetTime())
                                    if (timertextremain > 60) then
                                        timer:SetScale( buffscale*0.77 ) -- Scale down the timer text
                                    end
                                end
                                timeremain = 0
                            end
                        end
                    end)
                else
                    leftline:SetText(lefttext)
                    rightline:SetText(righttext)
                end
            end

            --Anchors
            local prev = UnitAura("target",i-1, "HELPFUL")
            if prev then
                _G["DUFBuffTooltip"..i]:SetPoint("BOTTOMLEFT", _G["DUFBuffTooltip"..i-1], "TOPLEFT", 0,4)
            else
                _G["DUFBuffTooltip"..i]:SetPoint("BOTTOMLEFT", DUFBuffTooltipParent, "BOTTOMLEFT", 0,0)
            end
        else
            if _G["DUFBuffTooltip"..i] then
                _G["DUFBuffTooltip"..i]:ClearLines()
                _G["DUFBuffTooltip"..i]:Hide()
            end
        end
    end
end

--Target Debuff Info Frames
local DUFDebuffTooltipParent = CreateFrame("Frame","DUFDebuffTooltipParent",UIParent)
DUFDebuffTooltipParent:RegisterEvent("PLAYER_LOGIN")
DUFDebuffTooltipParent:RegisterUnitEvent("UNIT_AURA", "player")
DUFDebuffTooltipParent:RegisterUnitEvent("PLAYER_TARGET_CHANGED")
DUFDebuffTooltipParent:SetMovable(true)
DUFDebuffTooltipParent:SetSize(40, 40)
DUFDebuffTooltipParent:SetFrameStrata("TOOLTIP")
DUFDebuffTooltipParent:SetClampedToScreen(true)
DUFDebuffTooltipParent:RegisterForDrag("LeftButton")
DUFDebuffTooltipParent:SetScript("OnDragStart", DUFDebuffTooltipParent.StartMoving)
DUFDebuffTooltipParent:SetScript("OnDragStop", DUFDebuffTooltipParent.StopMovingOrSizing)
DUFDebuffTooltipParent:SetPoint("BOTTOMRIGHT", UIParent, "CENTER", -198,68)
DUFDebuffTooltipParent:Show()

--statusbar background
local debugtexture = DUFDebuffTooltipParent:CreateTexture(nil, "BACKGROUND")
debugtexture:SetAllPoints(DUFDebuffTooltipParent)
debugtexture:SetTexture("Interface\\Tooltips\\UI-Tooltip-Background")
debugtexture:SetColorTexture(0, 0, 0, 0)

DUFDebuffTooltipParent:SetScript("OnEvent", function(self, event, ...)
    DUF_ScanDebuffs()
    C_Timer.After(0.01, DUF_ScanDebuffs) -- Double set so that buffs are not multiples of the same buff and so the text icon caches. Inefficient, but my best effort thus far.
end)

--####### #######

--Target Buff Info Frames
local DUFBuffTooltipParent = CreateFrame("Frame","DUFBuffTooltipParent",UIParent)
DUFBuffTooltipParent:RegisterEvent("PLAYER_LOGIN")
DUFBuffTooltipParent:RegisterUnitEvent("UNIT_AURA", "target")
DUFBuffTooltipParent:RegisterUnitEvent("PLAYER_TARGET_CHANGED")
DUFBuffTooltipParent:SetMovable(true)
DUFBuffTooltipParent:SetSize(40, 40)
DUFBuffTooltipParent:SetFrameStrata("TOOLTIP")
DUFBuffTooltipParent:SetClampedToScreen(true)
DUFBuffTooltipParent:RegisterForDrag("LeftButton")
DUFBuffTooltipParent:SetScript("OnDragStart", DUFBuffTooltipParent.StartMoving)
DUFBuffTooltipParent:SetScript("OnDragStop", DUFBuffTooltipParent.StopMovingOrSizing)
DUFBuffTooltipParent:SetPoint("BOTTOMLEFT", UIParent, "CENTER", 198,68)
DUFBuffTooltipParent:Show()

--statusbar background
local buffdebugtexture = DUFBuffTooltipParent:CreateTexture(nil, "BACKGROUND")
buffdebugtexture:SetAllPoints(DUFBuffTooltipParent)
buffdebugtexture:SetTexture("Interface\\Tooltips\\UI-Tooltip-Background")
buffdebugtexture:SetColorTexture(0, 0, 0, 0)

DUFBuffTooltipParent:SetScript("OnEvent", function(self, event, ...)
    DUF_ScanBuffs()
    C_Timer.After(0.01, DUF_ScanBuffs) -- Double set so that buffs are not multiples of the same buff and so the text icon caches. Inefficient, but my best effort thus far.
end)

--####### #######

--Slash Commands
SLASH_DUFLOCK1 = '/dbt'
SlashCmdList['DUFLOCK'] = function(msg, editbox) 
    if (DUFlocked == true) then
        DUFlocked = false
        debugtexture:SetColorTexture(0, 0.75, 1, 0.5)
        buffdebugtexture:SetColorTexture(0, 0.75, 1, 0.5)

        DUFDebuffTooltipParent:EnableMouse(true)
        DUFBuffTooltipParent:EnableMouse(true)
    else
        DUFlocked = true
        debugtexture:SetColorTexture(0, 0, 0, 0)
        buffdebugtexture:SetColorTexture(0, 0, 0, 0)

        DUFDebuffTooltipParent:EnableMouse(false)
        DUFBuffTooltipParent:EnableMouse(false)
    end
end

SLASH_DUFRESET1 = '/dbtreset'
SlashCmdList['DUFRESET'] = function(msg, editbox) 
    DUFlocked = true

    debugtexture:SetColorTexture(0, 0, 0, 0)
    DUFDebuffTooltipParent:EnableMouse(false)
    DUFDebuffTooltipParent:SetMovable(false)
    DUFDebuffTooltipParent:ClearAllPoints()
    DUFDebuffTooltipParent:SetPoint("BOTTOMRIGHT", UIParent, "CENTER", -198,68)
    DUFDebuffTooltipParent:SetMovable(true)    
    
    buffdebugtexture:SetColorTexture(0, 0, 0, 0)
    DUFBuffTooltipParent:EnableMouse(false)
    DUFBuffTooltipParent:SetMovable(false)
    DUFBuffTooltipParent:ClearAllPoints()
    DUFBuffTooltipParent:SetPoint("BOTTOMLEFT", UIParent, "CENTER", 198,68)
    DUFBuffTooltipParent:SetMovable(true)
end